package com.hai.config;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hai.common.pay.util.sdk.WXPayConstants;
import com.hai.common.utils.HttpsUtils;
import com.hai.common.utils.MD5Util;
import com.hai.common.utils.WxUtils;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.StringUtils;
import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.util.*;

/**
 * @author hurui
 * @version 1.0
 * @ClassName QianZhuConfig
 * @description: 汇联通接口配置
 * @date 2021/7/5 14:18
 */
public class HuiLianTongConfig {

    /**
     * 获取token
     * @return
     * @throws Exception
     */
    public static JSONObject getToken() throws Exception {
        Map<String,Object> map = new HashMap<>();
        map.put("appNo", "guizhouhltcs");
        map.put("appKey", MD5Util.encode("g%2BNnjR54YSUWM2iKg%2Fd82A9x9hg2kYV7".getBytes()));
        return HttpsUtils.doPost("https://gzapitest.deepermobile.com.cn:441/api/api/auth/getAccessToken", JSON.toJSONString(map));
    }

    public static JSONObject getCorpCouTypes() throws Exception {
        Map<String,Object> param = new HashMap<>();
        Map<String,Object> map = new HashMap<>();
        map.put("token", "a::57D9BBA185484EAD82737168B28EDA62");
        map.put("jsonData", get3DESEncryptECB(JSON.toJSONString(param), "FA28E95ACABFA4B2B8E25857437B07F1"));
        StringJoiner urlParamStr = new StringJoiner("&");
        urlParamStr.add(String.format("jsonData=%s", param));
        urlParamStr.add(String.format("secretKey=%s","FA28E95ACABFA4B2B8E25857437B07F1"));
        map.put("sign", md5Capital(urlParamStr.toString()));
        return HttpsUtils.doPost("https://gzapitest.deepermobile.com.cn:441/coupon/api/coupon_corp/getCorpCouTypes", JSON.toJSONString(map));
    }

    public static JSONObject couJointDist() throws Exception {
        // 券列表
        List<Map<String,Object>> objectList = new ArrayList<>();
        Map<String,Object> object = new HashMap<>();
        object.put("couTypeCode", "20JY000251");
        object.put("distCouCount", 1);
        objectList.add(object);

        // 参数
        Map<String,Object> param = new HashMap<>();
        param.put("coupons", objectList);
        param.put("phone", "17726395120");
        param.put("thirdUserId", "oArhO6XxKSvjI9wLP3cTK-iSG8yY");
        param.put("orderNo", "HF"+new Date().getTime());
        param.put("distOuCode", "guizhouhltcs");

        String appKey = "g%2BNnjR54YSUWM2iKg%2Fd82A9x9hg2kYV7";
        String appSecret = "FA28E95ACABFA4B2B8E25857437B07F1";

        Map<String,Object> map = new HashMap<>();
        map.put("token", "a::57D9BBA185484EAD82737168B28EDA62");
        map.put("jsonData", get3DESEncryptECB(JSON.toJSONString(param), appKey));

        StringJoiner joiner = new StringJoiner("&");
        joiner.add("jsonData=" + JSON.toJSONString(param));
        joiner.add("secretKey=" + appSecret);
        map.put("sign", md5Capital(joiner.toString()));

        Map<String,Object> map1 = new HashMap<>();
        String fromStr = "token="+MapUtils.getString(map, "token")+"&sign=" + MapUtils.getString(map, "sign")+"&jsonData=" + URLEncoder.encode(MapUtils.getString(map, "jsonData"),"UTF-8");
        map1.put("from", "");
        return HttpsUtils.doSmsPost("https://gzapitest.deepermobile.com.cn:441/coupon/api/coupon_corp/couJointDist?"+fromStr, map1, new HashMap<>());
    }

    public static void main(String[] args) throws UnsupportedEncodingException {
        String decode = URLDecoder.decode("jkE2O4ZKfL6F2IWQyf01oNXbCY%252FM1xZ7OP1%252BJVeXCfpWZgaFjIjZaVTPdJHkxRUlPJikskS6rQs1OMbMiu9ZgKaHftjA%252BJ7f%252BSFzsOPDPpnACegOBBR%252BjN5ZxOH%252FDPe9pOoGA53gBbAIEuqkDlqirxJyNR%252FJHip%252BoAQ2%252FN00pD1pIyvBqGsks%252Bx0w2w7GzYGcacU7iQrVHPhcFdyGFJUhWOaBMhRgNi0lJw9Pjt8xuY5IXwAjgk0EQ%253D%253D", "UTF-8");
        System.out.println(decode);
        System.out.println(get3DESDecryptECB(decode, "FA28E95ACABFA4B2B8E25857437B07F1"));
    }

    public static String get3DESEncryptECB(String src,String secretKey) {
        try {
            Cipher cipher = Cipher.getInstance("DESede/ECB/PKCS5Padding");
            cipher.init(Cipher.ENCRYPT_MODE, new SecretKeySpec(build3DesKey(secretKey), "DESede"));
            String base64Encode = getBase64Encode(cipher.doFinal(src.getBytes("UTF-8")));
            return filter(base64Encode);
        } catch (Exception ex) {
            //加密失败，打日志
//       //logger.error(ex,ex);
        }
        return null;
    }

    public static String get3DESDecryptECB(String src,String secretKey){
        try {
            Cipher cipher = Cipher.getInstance("DESede/ECB/PKCS5Padding");
            cipher.init(Cipher.DECRYPT_MODE, new SecretKeySpec(build3DesKey(secretKey), "DESede"));
            byte[] base64DValue = getBase64Decode(src);
            byte ciphertext[] = cipher.doFinal(base64DValue);
            return new String(ciphertext, "UTF-8");
        } catch (Exception e) {
            //解密失败，打日志
//       //logger.error(e,e);
        }
        return null;
    }

    /*
     * 根据字符串生成密钥字节数组
     * @param keyStr 密钥字符串
     * @return
     * @throws UnsupportedEncodingException
     */
    public static byte[] build3DesKey(String keyStr) throws UnsupportedEncodingException {
        byte[] key = new byte[24];    //声明一个24位的字节数组，默认里面都是0
        byte[] temp = keyStr.getBytes("UTF-8");    //将字符串转成字节数组

        /*
         * 执行数组拷贝
         * System.arraycopy(源数组，从源数组哪里开始拷贝，目标数组，拷贝多少位)
         */
        if(key.length > temp.length){
            //如果temp不够24位，则拷贝temp数组整个长度的内容到key数组中
            System.arraycopy(temp, 0, key, 0, temp.length);
        }else{
            //如果temp大于24位，则拷贝temp数组24个长度的内容到key数组中
            System.arraycopy(temp, 0, key, 0, key.length);
        }
        return key;
    }
    /**
     * 对字符串进行Base64编码
     *
     *
     * @return String 进行编码后的字符串
     */

    public static String getBase64Encode(byte[] src) {
        String requestValue = "";
        try {
            BASE64Encoder base64en = new BASE64Encoder();
            requestValue = filter(base64en.encode(src));
            // //logger.debug(requestValue);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return requestValue;
    }

    public static byte[] getBase64Decode(String str) {
        byte[] src = null;

        try {
            BASE64Decoder base64de = new BASE64Decoder();
            src = base64de.decodeBuffer(str);
        } catch (Exception var3) {
            var3.printStackTrace();
        }

        return src;
    }

    private static String filter(String str) {
        String output = null;
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < str.length(); i++) {
            int asc = str.charAt(i);
            if (asc != 10 && asc != 13)
                sb.append(str.subSequence(i, i + 1));
        }
        output = new String(sb);
        return output;
    }

    /**
     * 大写
     * @param s
     * @return
     */
    public static String md5Capital(String s){
        char hexDigits[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
        try {
            byte[] strTemp = s.getBytes();
            //使用MD5创建MessageDigest对象
            MessageDigest mdTemp = MessageDigest.getInstance("MD5");
            mdTemp.update(strTemp);
            byte[] md = mdTemp.digest();
            int j = md.length;
            char str[] = new char[j * 2];
            int k = 0;
            for (int i = 0; i < j; i++) {
                byte b = md[i];
                ////logger.debug((int)b);
                //将没个数(int)b进行双字节加密
                str[k++] = hexDigits[b >> 4 & 0xf];
                str[k++] = hexDigits[b & 0xf];
            }
            return new String(str);
        } catch (Exception e) {return null;}
    }
/*
    测试实例：
    String appkey = "q[*^%]#%675f";
    String param = "{\"phone\":\"18550231381\"}";
    String secretKey = "7EFD6D5D7052E29B4FBC4AD75CA737ED";
    String jsonData = Coder.get3DESEncryptECB(param, appkey);
System.out.println("jsonData:" + jsonData);

    StringJoiner joiner = new StringJoiner("&");
joiner.add("jsonData=" + param);
joiner.add("secretKey=" + secretKey);
    String sign = Coder.md5Capital(joiner.toString());
System.out.println("sign:" + sign);

    jsonData:aOF3MZAENbJE/t+r4P0+RQGfhSEa5Hyq
    sign:835A267FCA8D36C6F79E308F18AECEE8*/
}
